

{

Sync 'Em!
by Antti Kirjavainen
akirjavainen@mail.htk.fi

A program to synchronize your system time
and all the other computers in the network.

You can do what you like with this code,
but you may NOT publish it as another program.

}


program SyncTime;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  QForms,
  IdBaseComponent,
  IdComponent,
  IdTCPConnection,
  IdTCPClient,
  IdTime;

const
  ENTER = Chr(13) + Chr(10);
  SuccessMessage = 'System time has been synchronized!';
  FailMessage = 'Failed. Check that the server address is correct.';

var
  idGetTime : TidTime;
  ReportErrors : Boolean;
  Server : String;
  Port : Integer;
  posParams : Integer;
  CMDCommand : String;


function InStr(const sData, sFind: string): integer; overload;
begin
  result := Pos(sFind, sData);
end;

function InStr(nStart: integer; const sData, sFind: string): integer; overload;
var
  sTemp : String;
  nFound: integer;
begin
  sTemp  := Copy(sData, nStart, Length(sData) - (nStart - 1));
  nFound := Pos(sFind, sTemp);
  if nFound = 0 then
    result := 0
  else
    result := nFound + nStart - 1;
end;

function MidStr(const pString, pAbre, pFecha: String; pInclui: boolean): string;
var
  lIni, lFim : integer;
begin
  if (pInclui = False) then begin
    lIni := Pos(UpperCase(pAbre), UpperCase(pString)) + Length(pAbre);
    lFim := InStr(lIni, UpperCase(pString), UpperCase(pFecha));
  end else begin
    lIni := Pos(UpperCase(pAbre), UpperCase(pString));
    lFim := InStr(lIni + Length(pAbre), UpperCase(pString), UpperCase(pFecha)) + Length(pFecha);
  end;
  result := Copy(pString, lIni, lFim - lIni);
end;

procedure PauseProgram;
// Pause the program with Readln:
var
        Pause : String;

begin
Writeln('');
Writeln('Press any key to quit...');
Readln(Pause);
end;

begin

  Writeln('');
  Writeln('Sync ''Em! v2.1');
  Writeln('by Antti Kirjavainen');
  Writeln('');
  Writeln('akirjavainen@mail.htk.fi');
  Writeln('http://www.htk.fi/public/akirjavainen');
  Writeln('');
  Writeln('');

  // Set the defaults:
  Server := 'time-nw.nist.gov';
  Port := 37;


  // Get the command line parameters:
  CMDCommand := ParamStr(1);
  if (Pos('-?', CMDCommand) > 0) or (Pos('-h', CMDCommand) > 0) or (Pos('-H', CMDCommand) > 0) or (Pos('-?', CMDCommand) > 0) then begin
                                        Writeln('Command line parameters for Sync ''Em! client: ' + ENTER + ENTER + '-? = This help screen' + ENTER + '[server:port] = Server to use for synchronize' + ENTER + ENTER + 'Synchronizes your system time with a NTP-server.');
                                        Writeln('');
                                        Application.Terminate;
                                        exit;
                                        end;
  if (length(CMDCommand) > 0) then begin
                                        Server := CMDCommand;
                                        if (Length(ParamStr(2)) > 0) then Port := StrToIntDef(ParamStr(2), 37);
                                        end;


// Create the component:
  idGetTime := TidTime.Create(Application);
  idGetTime.Host := Server;
  idGetTime.Port := Port;


  Writeln('Contacting ' + Server + ':' + IntToStr(Port) + '...');
  

// ...and synchronize the time:
try
        if not idGetTime.SyncTime then begin
                                        Writeln(FailMessage);
                                        Writeln('');
                                        if ReportErrors then begin
                                                             PauseProgram;
                                                             end;
                                        end
                                        else begin
                                        Writeln(SuccessMessage);
                                        Writeln('');
                                        end;
except
        Writeln(FailMessage);
        Writeln('');
        if ReportErrors then begin
                             PauseProgram;
                             end;
end;


end.
